SystemOrganization addCategory: #OrionBrowser!

!ASMethod class methodsFor: '*OrionBrowser' stamp: 'AnneEtien 3/7/2013 11:31'!
addInModelVersion: aModelVersion withName: aName in: aClass

		aName  notNil ifTrue: [ 
		(ASActionAddMethod new
			antaresModel: aModelVersion ;
			containerClass: aClass ;
			stringName: aName )
		manualRun ]! !

!ASInvocation methodsFor: '*OrionBrowser' stamp: 'AnneEtien 3/4/2013 16:48'!
removeFromAModelVersion:  anASModel
	(ASActionRemoveInvocation new
		antaresModel: anASModel;
		entity: self )
	manualRun. ! !

!ASClass class methodsFor: '*OrionBrowser' stamp: 'AnneEtien 3/7/2013 16:14'!
addInModelVersion: aModelVersion withName: aName in: aPackage

		aName  notNil ifTrue: [ 
		(ASActionAddClass new
			antaresModel: aModelVersion ;
			package: aPackage ;
			stringName: aName )
		manualRun ]! !

!ASInheritance class methodsFor: '*OrionBrowser' stamp: 'AnneEtien 3/5/2013 11:26'!
addInModelVersion: aModelVersion from: aChildEntity to: aParentEntity

	(ASActionAddInheritance new
		antaresModel: aModelVersion ;
		child: aChildEntity ;
		entity: aChildEntity ;
		parent: aParentEntity )
	manualRun. ! !

!ASInheritance methodsFor: '*OrionBrowser' stamp: 'AnneEtien 3/4/2013 16:49'!
removeFromAModelVersion:  anASModel
	(ASActionRemoveInheritance new
		antaresModel: anASModel;
		entity: self )
	manualRun. 
! !

!ASReference methodsFor: '*OrionBrowser' stamp: 'AnneEtien 3/4/2013 16:53'!
removeFromAModelVersion:  anASModel
	(ASActionRemoveReference new
		antaresModel: anASModel;
		entity: self )
	manualRun. ! !

!ASAttribute class methodsFor: '*OrionBrowser' stamp: 'AnneEtien 3/5/2013 11:14'!
addInModelVersion: aModelVersion withName: aName in: aClass

		aName  notNil ifTrue: [ 
		(ASActionAddAttribute new
			antaresModel: aModelVersion ;
			entity: aClass ;
			stringName: aName )
		manualRun ]! !

ASAnnouncement subclass: #ASEntityBuffered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

Object subclass: #ASBrowser
	instanceVariableNames: 'selectedVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

!ASBrowser class methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:36'!
open 

	self new browser openOn: ASSystem root first! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
actionsFor: each
	|posAction elements listOfAct |

	elements :=  each selection mooseInterestingEntity.
	posAction := (((ASAction withAllSubclasses flatCollect: [:act | Pragma allNamed: #AntaresActionFor: in: act class])
					select:[:e | e arguments includes: elements class asString asSymbol]) collect:[:e | e methodClass soleInstance]) asOrderedCollection.
	listOfAct := OrderedCollection new.
	posAction do:[:ie | 
						|depend|
						depend := ie needs: elements.
						depend isNil 
							ifTrue:[
								listOfAct add:(
								(GLMAction new)
									action:[:anAct | 
										elements currentContext isModifiable ifTrue:[
											ie new entity: elements; antaresModel: elements currentContext; manualRun.
											elements currentContext system announcer announce: ASModelChanged]
										ifFalse:[
											ie new entity:elements; runOnNewVersionFrom: elements currentContext.
											elements currentContext system announcer announce: ASModelAdded
										]
									];
									title:ie description;
									yourself).]
							ifFalse:[
								depend do:[:anEl |
									listOfAct add:(
									(GLMAction new)
										action:[:anAct | 
											elements currentContext isModifiable ifTrue:[
												ie new entity:elements; to:anEl; antaresModel: elements currentContext; manualRun.
												elements currentContext system announcer announce: ASModelChanged]
											ifFalse:[
												ie new entity:elements; to:anEl; runOnNewVersionFrom: elements currentContext.
												elements currentContext system announcer announce: ASModelAdded]
										];
										title:anEl mooseName;
										category:ie description;
										yourself).]].				
				].
	^listOfAct.! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
browser
	"
		self new browser openOn: ASSystem root
	"
	| browser  |
	
	browser := GLMTabulator new.
	
	browser column: #models span: 1; column: [:c | c row:#versions; row: #changes] span: 1; column: #categories span: 4.
	(browser transmit) to: #models; andShow: [:b |
		b list
			format:[:system | system name];
			display: [:each | each ].
	].
	
	(browser transmit) from: #models; to: #versions; andShow: [:b | 
		b tree
			allExpanded;
			format:[:system | system name];
			display: [:each | each antaresModels select:[:om | om parentModel = nil]];
			children: [:each | each childrenModel];
			act: [:each | each selection inspect] entitled: 'inspect';
			act: [:each | |new|
				new := each selection createNewChildVersion. ASSystem announcer announce: ASModelAdded. browser announce: ASAnnouncement] entitled: 'create a child version';
			act: [:each | each selection delete. ASSystem announcer announce: ASModelRemoved. browser announce: ASAnnouncement] entitled: 'delete'.
	].
	(browser transmit) to: #changes; from: #versions; andShow: [:b |
		b list
			display: [:each | each changes];
			title: [ :each | each changes size asString, ' changes'].
	].
	(browser transmit) to: #categories; from: #versions; andShow: [:b |
		b finder
			show: [:a |
				a custom: (self groupList).
				a custom: self entityNavigation.
			].
	 ].
	browser subscribe: ASAnnouncement do: [browser update].
	^ browser! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 1/16/2013 10:13'!
displayFor: anObject
	| entity pragmaValueAssociations |
	entity := anObject mooseInterestingEntity.
	pragmaValueAssociations := entity complexPropertyPragmas collect: [ :pragma | 
		pragma -> (anObject mooseInterestingEntity perform: pragma selector) mooseInterestingEntity ].
	^ (pragmaValueAssociations
		reject: [ :association | 
			association value isNil or: [ 
				association value isCollection and: [ 
					association value isEmpty ] ] ])
		sorted: [:a :b | 
			(a key argumentAt: 1) asLowercase asString < (b key argumentAt: 1) asLowercase asString ]! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 1/16/2013 10:26'!
entityNavigation
	^ GLMListPresentation new
			title: 'Navigation';
			display: [ :anObject | |entity |
				entity := anObject mooseInterestingEntity.
				(entity mooseInterestingEntity isKindOf: FAMIXEntity) ifFalse:[self selectedVersion: entity] ifTrue:[entity currentContext: self selectedVersion.].
				self displayFor: entity value.
			];
			when: [:input | input mooseInterestingEntity isCollection not or: [input mooseInterestingEntity isKindOf: MooseModel] ];
			dynamicActionsOnSelection: [ :list | list selection mooseInterestingEntity mooseFinderActions ].! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
groupList
	^ GLMListPresentation new
			beMultiple;
			showOnly: 50;
			display: [:e | e mooseInterestingEntity];
			send: [:each | each isNil ifTrue: [nil] ifFalse: [each asMooseGroup]];
			format: #mooseName;
			title: [ :each | each mooseInterestingEntity size asString, ' items'];
			when: [:input | (input mooseInterestingEntity isKindOf: MooseGroup) or:[
					(input mooseInterestingEntity isKindOf: Collection) and:[(input mooseInterestingEntity isKindOf: ByteSymbol)not]]];
			dynamicActionsOnSelection: [ :list | OrderedCollection new 
					addAll: list selection mooseInterestingEntity mooseFinderActions;
					addAll: (self actionsFor: list);
					yourself].
				
	! !

!ASBrowser methodsFor: 'accessing' stamp: 'janniklaval 12/23/2012 08:25'!
selectedVersion
	^ selectedVersion! !

!ASBrowser methodsFor: 'accessing' stamp: 'janniklaval 12/23/2012 08:25'!
selectedVersion: anObject
	selectedVersion := anObject! !

Object subclass: #OrionBrowser
	instanceVariableNames: 'selectedVersion actionDict browser entityInSummary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

!OrionBrowser class methodsFor: 'as yet unclassified' stamp: 'na 1/19/2013 12:46'!
open 

	self new browser openOn: ASSystem root! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 3/5/2013 11:06'!
addAttributeInAClass: aClass
	| newName |
	
	newName := self getNameDialogue:  'New class name'.
	newName notNil ifTrue: [ASAttribute addInModelVersion: (self selectedVersion) withName: newName in: aClass ]

	
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 3/4/2013 18:42'!
addClassIn: aPackage
	| newName |
	
	newName := self getNameDialogue:  'New class name'.

	newName notNil ifTrue: [ASClass addInModelVersion: self selectedVersion withName: newName in: aPackage  ]

	
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 3/5/2013 11:23'!
addInheritanceFrom: aChildEntity to: aParentEntity
	

	ASInheritance addInModelVersion: self selectedVersion from: aChildEntity to: aParentEntity

	
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 3/4/2013 17:07'!
addLink: aLink to: anEntity
	

	aLink addInModelVersion: self selectedVersion to: anEntity 

	
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 3/5/2013 11:05'!
addMethodInAClass: aClass
	| newName |
	
	newName := self getNameDialogue:  'New class name'.
	newName notNil ifTrue: [ASMethod addInModelVersion: (self selectedVersion) withName: newName in: aClass ]

	
! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 2/21/2013 16:55'!
browser

	browser := GLMTabulator new.
	
	browser
		title: 'Orion Browser' ;
		column: [:c | c
				row:  #models ;
				row: #buffer size: 60 ]  span: 2 ;
		column: #packages  span: 2 ;
		column: #classes  span: 2 ;
		column: [:c | c
				row:  #attributes ;
				row:  #methods ]   span: 2 ;
		column: #links  span: 2 ;
		column: #summary span: 3.

	self
		browserModels ;
		browserBuffer ;
		browserPackages ;
		browserClasses ;
		browserAttributes ;
		browserMethods ;
		browserLinks ;
		browserSummary.
	
	browser subscribe: ASAnnouncement do: [ browser update].
	^ browser! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 2/20/2013 15:34'!
browserAttributes
	(browser transmit) to: #attributes; from: #classes; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | (anEntity attributes )  sorted: [:c1 :c2 | c1 name < c2 name] ];
			title: [ :each | ' Attributes'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect'.
		
		self contextMenuOn: gmlList action: #removeAttribute entitled: 'Remove'.			
		self contextMenuOn: gmlList moveAction: #moveAttribute entitled: 'Move to other class'.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 2/28/2013 11:16'!
browserBuffer

	(browser transmit) to: #buffer; from: #packages port: #strongSelection; andShow: [:a |
		a list
			display: [:anEntity | {anEntity} ];
			"format: [:entity | entity name] ;"
			title: 'Buffered'
	].

	(browser transmit) to: #buffer; from: #classes port: #strongSelection; andShow: [:a |
		a list
			display: [:anEntity | {anEntity} ];
			"format: [:entity | entity name] ;"
			title: 'Buffered'
	].

	(browser transmit) to: #buffer; from: #methods port: #strongSelection; andShow: [:a |
		a list
			display: [:anEntity | {anEntity} ];
			"format: [:entity | entity name] ;"
			title: 'Buffered'
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 3/5/2013 13:11'!
browserClasses

	
	
	"don't ask, it works for the specific browser
	Baiscally, it goes into the #browser pane to get the sole element it contains (value of #entity port)"
	"entityInBuffer :=  [((browser panes detect: [:p | p name = #buffer]) port: #entity) value ]".
	(browser transmit) to: #classes; from: #packages; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | (anEntity classes)  sorted: [:c1 :c2 | c1 name < c2 name]];
			title: [ :each | ' Classes'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' .
	
		gmlList selectionAct:  [:list | self addInheritanceFrom: ( list selection) to: entityInSummary ]  entitled: 'Add inheritance from the buffered class'.
		"self contextMenuOn: gmlList moveAction: #addInheritance entitled: 'Add inheritance from the buffered class'."
		"self contextMenuOn: gmlList action: #addAttribute entitled: 'Add attribute'."
		gmlList selectionAct:  [:list | self addAttributeInAClass: ( list selection)]  entitled: 'Add attribute'.	
		gmlList selectionAct:  [:list | self addMethodInAClass: ( list selection)]  entitled: 'Add method'.		
		"self contextMenuOn: gmlList action: #addMethod entitled: 'Add method'."
		self contextMenuOn: gmlList action: #removeClass entitled: 'Remove'.			
		self contextMenuOn: gmlList moveAction: #moveClass entitled: 'Move to buffered package'.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 3/4/2013 16:56'!
browserLinks

	"{#classes . #methods . #attributes} do: [:srcPanel |"

	(browser transmit) to: #links ; from: #classes ; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			title: 'Links' ;
			display: [ :anObject | (((anObject privateIncomingReferences) union: (anObject privateSuperInheritances  )) union: (anObject privateSubInheritances) ) sorted: [:x :y | x mooseName < y mooseName]] ;
			 
			format: [:aProp | (aProp asString)];
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' .

		gmlList selectionAct:  [:list | self remove:( list selection)]  entitled: 'Remove the Link'.
		"self contextMenuOn: gmlList action:  [:list | list selection remove:self]  entitled: 'Remove Link'."
			"when: [ :anObject | 
				(anObject mooseInterestingEntity isKindOf: MooseEntity) and: [
					anObject privateSuperInheritances notEmpty or: anObject privateIncomingReferences notEmpty ]]]"
		].
	

	
	(browser transmit) to: #links ; from: #methods ; andShow:[:b | | gmlList |
		gmlList := b list.
		gmlList
			title: 'Links' ;
			display: [ :anObject | (anObject privateOutgoingReferences ) 
					union: ((anObject privateIncomingInvocations) union: (anObject privateOutgoingInvocations  )) ] ;
			sorted: [:x :y | x mooseName < y mooseName] ;
			format: [:aProp | (aProp asString)];
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' .
			
			gmlList selectionAct:  [:list | self remove:( list selection)]  entitled: 'Remove the Link'.
			"when: [ :anObject | 
				(anObject mooseInterestingEntity isKindOf: MooseEntity) and: [
					anObject privateSuperInheritances notEmpty or: anObject privateIncomingReferences notEmpty ]]]"
		].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 2/28/2013 11:11'!
browserMethods
	(browser transmit) to: #methods; from: #classes; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | (anEntity methods)  sorted: [:c1 :c2 | c1 name < c2 name] ];
			title: [ :each | ' Methods'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect'.
		
		self contextMenuOn: gmlList action: #removeMethod entitled: 'Remove'.			
		self contextMenuOn: gmlList moveAction: #moveMethod entitled: 'Move to other class'.
		self contextMenuOn: gmlList moveAction: #addReference entitled: 'Add reference to the buffered class'.
		self contextMenuOn: gmlList moveAction: #addInvocation entitled: 'Add invocation to the buffered method'.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 2/2/2013 11:32'!
browserModels

	(browser transmit) to: #models; andShow: [:b | | gmlTree |
		gmlTree := b tree.
		gmlTree
			allExpanded;
			display: [:systems | systems flatCollect: [:aSystem | aSystem antaresModels select:[:versions | versions parentModel isNil]]];
			format:[:aVersion | aVersion name];
			children: [:aVersion | aVersion childrenModel] ;

			selectionAct: [:list | list selection inspect] entitled:  'Inspect';

			selectionAct: [:theList | 
						theList selection createNewChildVersion.
						browser announce: ASAnnouncement]
				entitled: 'Create a child version' ;

			selectionAct: [:theList | 
						theList selection delete.
						browser announce: ASAnnouncement]
				entitled: 'Delete version' .

		self	versionChangesPane: gmlTree.
		self contextMenuOn: gmlTree action: #addPackage entitled: 'Add a package'.	
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 3/4/2013 18:43'!
browserPackages

	(browser transmit) to: #packages ; from:#models; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:model |
				self selectedVersion: model.
				(model allWithType: ASPackage) sorted: [:c1 :c2 | c1 name < c2 name] ] ;
			title: [ :each | ' Packages'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect'.

		"self contextMenuOn: gmlList action: #addClass entitled: 'Add class'.	"
		gmlList selectionAct:  [:list | self addClassIn: ( list selection)]  entitled: 'Add an Entity'.		
		self contextMenuOn: gmlList action: #removePackage entitled: 'Remove'.	
		self contextMenuOn: gmlList moveAction: #mergePackage entitled: 'Merge with buffered package'.		
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 1/29/2013 18:06'!
browserSummary

	{#models . #packages .  #classes . #methods} do: [:srcPanel |

	(browser transmit) to: #summary ; from: srcPanel ; andShow: [:b |
		b  list
			noSelection ;
			title: 'Properties' ;
			display: [ :anObject | entityInSummary := anObject. anObject mooseInterestingEntity mooseDescription allPrimitiveAttributes ] ;
			sorted: [:x :y | x name < y name] ;
			format: [:aProp | aProp name ,  '= ' ,  ([(entityInSummary mooseInterestingEntity mmGetProperty: aProp) asString] on: Error do: ['error']) ]  ;
			when: [ :anObject | 
				(anObject mooseInterestingEntity isKindOf: MooseEntity) and: [
					anObject mooseInterestingEntity mooseDescription allPrimitiveAttributes notEmpty ]]]
		].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/17/2013 17:54'!
contextMenuOn: gmlPresentation action: aToken entitled: aString

	gmlPresentation selectionAct: [:list | self doAction: aToken onEntity: (list selection)] entitled: aString.
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 1/29/2013 19:27'!
contextMenuOn: gmlList moveAction: aToken entitled: aString
	
	| entityInBuffer |
	
	"don't ask, it works for the specific browser
	Baiscally, it goes into the #browser pane to get the sole element it contains (value of #entity port)"
	entityInBuffer :=  [((browser panes detect: [:p | p name = #buffer]) port: #entity) value ].
	
	gmlList selectionAct: [:list |
			self doMoveAction: aToken
				onEntity: (list selection) 
				withContainerFrom: entityInBuffer]
		entitled: aString.
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/21/2013 19:35'!
displayFor: anObject
	| entity pragmaValueAssociations |
	entity := anObject mooseInterestingEntity.
	pragmaValueAssociations := entity complexPropertyPragmas collect: [ :pragma | 
		pragma -> (anObject mooseInterestingEntity perform: pragma selector) mooseInterestingEntity ].
	^ (pragmaValueAssociations
		reject: [ :association | 
			association value isNil or: [ 
				association value isCollection and: [ 
					association value isEmpty ] ] ])
		sorted: [:a :b | 
			(a key argumentAt: 1) asLowercase asString < (b key argumentAt: 1) asLowercase asString ]! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/19/2013 10:58'!
doAction: anAction onEntity: anEntity

	self perform: (actionDict at: anAction) with: anEntity .

	browser announce: ASAnnouncement.! !

!OrionBrowser methodsFor: 'actions' stamp: 'NicolasAnquetil 1/29/2013 18:49'!
doMoveAction: anAction onEntity: anEntity withContainerFrom: aBlock

	self perform: (actionDict at: anAction) with: anEntity with: aBlock value.

	browser announce: ASAnnouncement.! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 3/5/2013 13:01'!
entityInBuffer 
	self halt.
	"don't ask, it works for the specific browser
	Baiscally, it goes into the #browser pane to get the sole element it contains (value of #entity port)"
	^  [(((browser panes) detect: [:p | p name = #buffer]) port: #entity) value ].
	
	
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/21/2013 19:50'!
formatFor: each
	^ (' ' join: ((each key argumentAt: 1) piecesCutWhereCamelCase collect: #capitalized)) , ' - ' , (each value mooseDisplayString contractTo: 50)! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/19/2013 13:43'!
getNameDialogue: aString
	
	| wizardControl  wizardPane textFieldPart defaultText |

	defaultText :=  '--Enter name--'.
	
	wizardControl := WizardControl new.
	wizardControl renderer: MerlinMorphicWizardRenderer new.
	
	wizardPane := WizardSinglePane new.
	
	textFieldPart := TextFieldPart  new
									inGroupboxNamed: aString;
									defaultValue: defaultText ;
									yourself.
	
	wizardPane row: textFieldPart associatedTo: #textFieldValue.
		
	wizardControl 
		addPane: wizardPane.
		
	wizardControl open. 
	((wizardControl wizardInformations at: #textFieldValue) = defaultText)
		ifTrue: [^ nil]
		ifFalse: [^ wizardControl wizardInformations at: #textFieldValue]! !

!OrionBrowser methodsFor: 'initialize-release' stamp: 'AnneEtien 3/1/2013 12:32'!
initialize 

	actionDict := SmallDictionary new.
	actionDict
		at: #addPackage put: #myAddPackage: ;
		at: #removePackage put: #myRemovePackage: ;
		at: #mergePackage put: #myMergePackage:with: ;
		at: #addClass put: #myAddClass: ;
		at: #addMethod put: #myAddMethod: ;
		at: #addAttribute put: #myAddAttribute: ;
		at: #removeClass put: #myRemoveClass: ;
		at: #moveClass put: #myMoveClass:to: ;
		at: #removeMethod put: #myRemoveMethod: ;
		at: #moveMethod put: #myMoveMethod:to: ;
		at: #removeAttribute put: #myRemoveAttribute: ;
		at: #removeLink put: #myRemoveLink: ;
		at: #moveAttribute put: #myMoveAttribute:to: ;
		at: #addInheritance put: #myAddInheritance:to: ;
		at: #addInvocation put: #myAddInvocation:to: ;
		at: #addReference put: #myAddReference:to: .
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 3/4/2013 12:54'!
myAddAttribute: anEntity
	| newName |
	
	newName := self getNameDialogue:  'New attribute name'.

	newName notNil ifTrue: [ 
		(ASActionAddAttribute new
			antaresModel: (self selectedVersion);
			entity: anEntity ;
			stringName: newName )
		manualRun ]
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/20/2013 10:30'!
myAddClass: anEntity
	| newName |
	
	newName := self getNameDialogue:  'New class name'.

	newName notNil ifTrue: [ 
		(ASActionAddClass new
			antaresModel: self selectedVersion;
			entity: anEntity ;
			stringName: newName )
		manualRun ]
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 2/22/2013 12:58'!
myAddInheritance: anEntity to: aSuperClass

	
	(ASActionAddInheritance new
		antaresModel: self selectedVersion;
		child: anEntity ;
		entity: anEntity ;
		parent: aSuperClass )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 3/4/2013 13:30'!
myAddInvocation: anEntity to: aMethod

	
	(ASActionAddInvocation new
		antaresModel: self selectedVersion;
		from: anEntity ;
		to: aMethod ;
		signature: aMethod signature)
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 2/13/2013 11:18'!
myAddMethod: anEntity
	| newName |
	
	newName := self getNameDialogue:  'New method name'.

	newName notNil ifTrue: [ 
		(ASActionAddMethod new
			antaresModel: self selectedVersion;
			entity: anEntity ;
			stringName: newName )
		manualRun ]
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/20/2013 10:31'!
myAddPackage: anEntity
	| newName |
	newName := self getNameDialogue:  'New package name'.

	newName notNil ifTrue: [ 
		(ASActionAddPackage new
			antaresModel: self selectedVersion;
			entity: anEntity ;
			stringName: newName )
		manualRun ]
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 2/28/2013 10:45'!
myAddReference: anEntity to: aClass

	
	(ASActionAddReference new
		antaresModel: self selectedVersion;
		from: anEntity ;
		entity: anEntity ;
		to: aClass )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 2/13/2013 13:26'!
myMergePackage: anEntity with: newPackage

	
	(ASActionMergePackage  new
		antaresModel: self selectedVersion;
		entity: anEntity ;
		newContainer: newPackage )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 2/21/2013 10:58'!
myMoveAttribute: anEntity to: newClass

	(ASActionMoveAttribute  new
		antaresModel: self selectedVersion;
		entity: anEntity ;
		newContainer: newClass )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/20/2013 10:31'!
myMoveClass: anEntity to: newPackage

	
	(ASActionMoveClass new
		antaresModel: self selectedVersion;
		entity: anEntity ;
		newContainer: newPackage )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/20/2013 10:31'!
myMoveMethod: anEntity to: newClass

	(ASActionMoveMethod new
		antaresModel: self selectedVersion;
		entity: anEntity ;
		newContainer: newClass )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 2/21/2013 11:31'!
myRemoveAttribute: anEntity

	(ASActionRemoveAttribute new
		antaresModel: self selectedVersion;
		entity: anEntity )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/20/2013 10:31'!
myRemoveClass: anEntity

	(ASActionRemoveClass new
		antaresModel: self selectedVersion;
		entity: anEntity )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 2/28/2013 16:59'!
myRemoveInheritance: anEntity

	(ASActionRemoveInheritance new
		antaresModel: self selectedVersion;
		entity: anEntity )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 3/4/2013 13:19'!
myRemoveLink: aLink

	(ASActionRemoveLink new
		antaresModel: self selectedVersion;
		entity: aLink )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/20/2013 10:31'!
myRemoveMethod: anEntity

	(ASActionRemoveMethod new
		antaresModel: self selectedVersion;
		entity: anEntity )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'na 1/20/2013 10:31'!
myRemovePackage: anEntity

	(ASActionRemovePackage new
		antaresModel: self selectedVersion;
		entity: anEntity )
	manualRun. 
! !

!OrionBrowser methodsFor: 'actions' stamp: 'AnneEtien 3/4/2013 16:53'!
remove: anEntity

	anEntity removeFromAModelVersion: self selectedVersion.
! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:20'!
selectedClassBottom
	^ selectedClassBottom! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:20'!
selectedClassBottom: anObject
	selectedClassBottom := anObject! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedClassTop
	^ selectedClassTop! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedClassTop: anObject
	selectedClassTop := anObject! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedPackageBottom
	^ selectedPackageBottom! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedPackageBottom: anObject
	selectedPackageBottom := anObject! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedPackageTop
	^ selectedPackageTop! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/16/2013 22:19'!
selectedPackageTop: anObject
	selectedPackageTop := anObject! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/15/2013 15:31'!
selectedVersion
	^ selectedVersion! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/15/2013 15:31'!
selectedVersion: anObject
	selectedVersion := anObject! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/20/2013 11:41'!
versionChangesPane: gmlTree

		gmlTree
			selectionSpawn: [:theList |
				|tmpBrowser|
				tmpBrowser := GLMTabulator new row: #one; "initialExtent: 100@100 ;" yourself.
				tmpBrowser
					transmit to: #one ; andShow: [:brows |
						brows tree
							display: [:aVersion | aVersion changes select: [:chg | chg parentAction isNil]] ;
							children: [:aChange | aChange childrenActions];
							format:[:aChange | aChange printWorkspace];
							title: [ :aVersion | ' Changes in ' , (aVersion name)] ].
				tmpBrowser startOn: theList selection
				] entitled: 'List changes' .! !
